
import os
import pyuno
#import uno
from com.sun.star.beans import PropertyValue


def listFilterNames( lo ):
    oFF = lo.smgr.createInstanceWithContext( "com.sun.star.document.FilterFactory", lo.ctx )
    oFilterNames = oFF.getElementNames()
    print( oFilterNames );
#

def convert_path_to_url(path):
    return pyuno.systemPathToFileUrl( os.path.realpath( path ) )
#

def saveTextAs_WithFilter( model, filename, output_filter ):
    sFile= convert_path_to_url( filename )
    print("writing: ", sFile)
    saveProps = []
    p = PropertyValue()
    p.Name = 'FilterName'
    #p.Value = 'writer_pdf_Export'
    # Wrong: p.Value = 'writer_globaldocument_StarOffice_XML_Writer_GlobalDocument'
    #p.Value = 'MS Word 97' # OK
    p.Value = 'writer8' # for .odt
    saveProps.append(p)
    #
    p = PropertyValue()
    p.Name = "Overwrite"
    p.Value = True
    saveProps.append(p)
    #
    saveProps2 = tuple(saveProps)
    #
    model.storeAsURL(sFile, saveProps2)
    return
#

def saveTextAsOdt(      model, filename ): saveTextAs_WithFilter( model, filename, 'writer8'    )
def saveTextAsMsWord97( model, filename ): saveTextAs_WithFilter( model, filename, 'MS Word 97' )

